module statistics
   implicit none
   integer, parameter :: myk = kind(1.d0)

contains

   subroutine init(a)
      real(myk), intent(out) :: a(:)
      integer :: i
      do i=1,size(a)
         a(i) = i-1
      end do
   end subroutine init

   function avg_var_fun(a, var)
      real(myk) :: avg_var_fun,avg
      real(myk), intent(out) :: var
      real(myk), intent(in) :: a(:)
      integer :: N, i
      write(*,*) "computing mean and variance in Fortran/"
      N = size(a)
      avg = 0.; var = 0.
      do i=1,N
         avg = avg + a(i)
         var = var + a(i)*a(i)
      end do
      avg = avg/N
      var = var/N - avg*avg
      avg_var_fun = avg
   end function avg_var_fun

end module statistics
